Linux ip-172-26-5-244 6.1.0-28-cloud-amd64 #1 SMP PREEMPT_DYNAMIC Debian 6.1.119-1 (2024-11-22) x86_64
Apache
: 172.26.5.244 | : 216.73.216.21
Cant Read [ /etc/named.conf ]
8.3.14
daemon
Terminal
AUTO ROOT
Adminer
Backdoor Destroyer
Linux Exploit
Lock Shell
Lock File
Create User
CREATE RDP
PHP Mailer
BACKCONNECT
UNLOCK SHELL
HASH IDENTIFIER
README
+ Create Folder
+ Create File
/
usr /
sbin /
[ HOME SHELL ]
Name
Size
Permission
Action
aa-remove-unknown
3.13
KB
-rwxr-xr-x
aa-status
38.3
KB
-rwxr-xr-x
aa-teardown
137
B
-rwxr-xr-x
accessdb
14.46
KB
-rwxr-xr-x
add-shell
1.03
KB
-rwxr-xr-x
addgroup
47.25
KB
-rwxr-xr-x
adduser
47.25
KB
-rwxr-xr-x
agetty
67.49
KB
-rwxr-xr-x
apparmor_parser
1.39
MB
-rwxr-xr-x
apparmor_status
38.3
KB
-rwxr-xr-x
arp
66.13
KB
-rwxr-xr-x
arpd
104.48
KB
-rwxr-xr-x
arptables
223.16
KB
-rwxr-xr-x
arptables-nft
223.16
KB
-rwxr-xr-x
arptables-nft-restore
223.16
KB
-rwxr-xr-x
arptables-nft-save
223.16
KB
-rwxr-xr-x
arptables-restore
223.16
KB
-rwxr-xr-x
arptables-save
223.16
KB
-rwxr-xr-x
atd
30.09
KB
-rwxr-xr-x
badblocks
34.25
KB
-rwxr-xr-x
blkdeactivate
15.96
KB
-rwxr-xr-x
blkdiscard
34.31
KB
-rwxr-xr-x
blkid
122.34
KB
-rwxr-xr-x
blkzone
78.31
KB
-rwxr-xr-x
blockdev
78.31
KB
-rwxr-xr-x
bridge
152.54
KB
-rwxr-xr-x
capsh
53.29
KB
-rwxr-xr-x
cfdisk
106.66
KB
-rwxr-xr-x
cgdisk
210.41
KB
-rwxr-xr-x
chcpu
46.3
KB
-rwxr-xr-x
chgpasswd
66.29
KB
-rwxr-xr-x
chmem
66.31
KB
-rwxr-xr-x
chpasswd
62.36
KB
-rwxr-xr-x
chroot
46.98
KB
-rwxr-xr-x
cpgr
60.43
KB
-rwxr-xr-x
cppw
60.43
KB
-rwxr-xr-x
cron
50.56
KB
-rwxr-xr-x
ctrlaltdel
38.3
KB
-rwxr-xr-x
dcb
144.6
KB
-rwxr-xr-x
debugfs
233.83
KB
-rwxr-xr-x
delgroup
16.33
KB
-rwxr-xr-x
deluser
16.33
KB
-rwxr-xr-x
depmod
174.27
KB
-rwxr-xr-x
devlink
220.98
KB
-rwxr-xr-x
dhclient
2.63
MB
-rwxr-xr-x
dhclient-script
14.21
KB
-rwxr-xr-x
dmsetup
166.98
KB
-rwxr-xr-x
dmstats
166.98
KB
-rwxr-xr-x
dpkg-fsys-usrunmess
16.99
KB
-rwxr-xr-x
dpkg-preconfigure
3.83
KB
-rwxr-xr-x
dpkg-reconfigure
4.38
KB
-rwxr-xr-x
dumpe2fs
30.31
KB
-rwxr-xr-x
e2freefrag
14.3
KB
-rwxr-xr-x
e2fsck
348.27
KB
-rwxr-xr-x
e2image
54.45
KB
-rwxr-xr-x
e2label
114.52
KB
-rwxr-xr-x
e2mmpstatus
30.31
KB
-rwxr-xr-x
e2scrub
7.12
KB
-rwxr-xr-x
e2scrub_all
5.27
KB
-rwxr-xr-x
e2undo
22.3
KB
-rwxr-xr-x
e4crypt
26.3
KB
-rwxr-xr-x
e4defrag
30.23
KB
-rwxr-xr-x
ebsnvme-id
6.89
KB
-rwxr-xr-x
ebtables
223.16
KB
-rwxr-xr-x
ebtables-nft
223.16
KB
-rwxr-xr-x
ebtables-nft-restore
223.16
KB
-rwxr-xr-x
ebtables-nft-save
223.16
KB
-rwxr-xr-x
ebtables-restore
223.16
KB
-rwxr-xr-x
ebtables-save
223.16
KB
-rwxr-xr-x
ebtables-translate
223.16
KB
-rwxr-xr-x
ethtool
592.45
KB
-rwxr-xr-x
faillock
14.24
KB
-rwxr-xr-x
fdisk
158.35
KB
-rwxr-xr-x
filefrag
18.26
KB
-rwxr-xr-x
findfs
14.3
KB
-rwxr-xr-x
fixparts
74.4
KB
-rwxr-xr-x
fsck
54.36
KB
-rwxr-xr-x
fsck.cramfs
42.37
KB
-rwxr-xr-x
fsck.ext2
348.27
KB
-rwxr-xr-x
fsck.ext3
348.27
KB
-rwxr-xr-x
fsck.ext4
348.27
KB
-rwxr-xr-x
fsck.minix
122.34
KB
-rwxr-xr-x
fsfreeze
14.3
KB
-rwxr-xr-x
fstab-decode
14.23
KB
-rwxr-xr-x
fstrim
74.31
KB
-rwxr-xr-x
gdisk
218.41
KB
-rwxr-xr-x
genl
116.51
KB
-rwxr-xr-x
getcap
14.23
KB
-rwxr-xr-x
getpcaps
14.23
KB
-rwxr-xr-x
getty
67.49
KB
-rwxr-xr-x
groupadd
99.04
KB
-rwxr-xr-x
groupdel
86.85
KB
-rwxr-xr-x
groupmems
66.33
KB
-rwxr-xr-x
groupmod
99.01
KB
-rwxr-xr-x
grpck
66.3
KB
-rwxr-xr-x
grpconv
58.14
KB
-rwxr-xr-x
grpunconv
58.14
KB
-rwxr-xr-x
grub-install
1.14
MB
-rwxr-xr-x
grub-macbless
922.26
KB
-rwxr-xr-x
grub-mkconfig
8.46
KB
-rwxr-xr-x
grub-mkdevicemap
216.7
KB
-rwxr-xr-x
grub-probe
934.57
KB
-rwxr-xr-x
grub-reboot
4.73
KB
-rwxr-xr-x
grub-set-default
3.47
KB
-rwxr-xr-x
halt
1.29
MB
-rwxr-xr-x
haveged
30.8
KB
-rwxr-xr-x
hwclock
86.44
KB
-rwxr-xr-x
iconvconfig
30.84
KB
-rwxr-xr-x
ifconfig
82.01
KB
-rwxr-xr-x
init
90.38
KB
-rwxr-xr-x
insmod
174.27
KB
-rwxr-xr-x
install-sgmlcatalog
4.44
KB
-rwxr-xr-x
installkernel
2.6
KB
-rwxr-xr-x
invoke-rc.d
16.13
KB
-rwxr-xr-x
ip
674.82
KB
-rwxr-xr-x
ip6tables
223.16
KB
-rwxr-xr-x
ip6tables-apply
6.87
KB
-rwxr-xr-x
ip6tables-legacy
88.98
KB
-rwxr-xr-x
ip6tables-legacy-restore
88.98
KB
-rwxr-xr-x
ip6tables-legacy-save
88.98
KB
-rwxr-xr-x
ip6tables-nft
223.16
KB
-rwxr-xr-x
ip6tables-nft-restore
223.16
KB
-rwxr-xr-x
ip6tables-nft-save
223.16
KB
-rwxr-xr-x
ip6tables-restore
223.16
KB
-rwxr-xr-x
ip6tables-restore-translate
223.16
KB
-rwxr-xr-x
ip6tables-save
223.16
KB
-rwxr-xr-x
ip6tables-translate
223.16
KB
-rwxr-xr-x
ipmaddr
18.56
KB
-rwxr-xr-x
iptables
223.16
KB
-rwxr-xr-x
iptables-apply
6.87
KB
-rwxr-xr-x
iptables-legacy
88.98
KB
-rwxr-xr-x
iptables-legacy-restore
88.98
KB
-rwxr-xr-x
iptables-legacy-save
88.98
KB
-rwxr-xr-x
iptables-nft
223.16
KB
-rwxr-xr-x
iptables-nft-restore
223.16
KB
-rwxr-xr-x
iptables-nft-save
223.16
KB
-rwxr-xr-x
iptables-restore
223.16
KB
-rwxr-xr-x
iptables-restore-translate
223.16
KB
-rwxr-xr-x
iptables-save
223.16
KB
-rwxr-xr-x
iptables-translate
223.16
KB
-rwxr-xr-x
iptunnel
26.55
KB
-rwxr-xr-x
isosize
30.31
KB
-rwxr-xr-x
killall5
26.31
KB
-rwxr-xr-x
ldattach
34.31
KB
-rwxr-xr-x
ldconfig
959.84
KB
-rwxr-xr-x
locale-gen
1.38
KB
-rwxr-xr-x
logrotate
98.16
KB
-rwxr-xr-x
logsave
14.09
KB
-rwxr-xr-x
losetup
114.42
KB
-rwxr-xr-x
lsmod
174.27
KB
-rwxr-xr-x
mii-tool
27.08
KB
-rwxr-xr-x
mke2fs
138.58
KB
-rwxr-xr-x
mkfs
14.3
KB
-rwxr-xr-x
mkfs.bfs
34.31
KB
-rwxr-xr-x
mkfs.cramfs
42.24
KB
-rwxr-xr-x
mkfs.ext2
138.58
KB
-rwxr-xr-x
mkfs.ext3
138.58
KB
-rwxr-xr-x
mkfs.ext4
138.58
KB
-rwxr-xr-x
mkfs.minix
110.32
KB
-rwxr-xr-x
mkhomedir_helper
22.27
KB
-rwxr-xr-x
mkinitramfs
12.4
KB
-rwxr-xr-x
mklost+found
14.23
KB
-rwxr-xr-x
mkswap
114.31
KB
-rwxr-xr-x
modinfo
174.27
KB
-rwxr-xr-x
modprobe
174.27
KB
-rwxr-xr-x
nameif
14.65
KB
-rwxr-xr-x
netplan
798
B
-rwxr-xr-x
newusers
102.92
KB
-rwxr-xr-x
nfnl_osf
18.23
KB
-rwxr-xr-x
nologin
14.23
KB
-rwxr-xr-x
pam-auth-update
20.79
KB
-rwxr-xr-x
pam_getenv
2.82
KB
-rwxr-xr-x
pam_namespace_helper
467
B
-rwxr-xr-x
pam_timestamp_check
14.24
KB
-rwxr-xr-x
pivot_root
14.3
KB
-rwxr-xr-x
plipconfig
14.48
KB
-rwxr-xr-x
poweroff
1.29
MB
-rwxr-xr-x
pwck
58.26
KB
-rwxr-xr-x
pwconv
54.13
KB
-rwxr-xr-x
pwhistory_helper
18.24
KB
-rwxr-xr-x
pwunconv
54.17
KB
-rwxr-xr-x
rarp
37.13
KB
-rwxr-xr-x
readprofile
34.34
KB
-rwxr-xr-x
reboot
1.29
MB
-rwxr-xr-x
remove-shell
1.08
KB
-rwxr-xr-x
resize2fs
62.3
KB
-rwxr-xr-x
resolvconf
146.53
KB
-rwxr-xr-x
rmmod
174.27
KB
-rwxr-xr-x
rmt
59.02
KB
-rwxr-xr-x
rmt-tar
59.02
KB
-rwxr-xr-x
route
69.17
KB
-rwxr-xr-x
rtacct
44.37
KB
-rwxr-xr-x
rtcwake
46.31
KB
-rwxr-xr-x
rtmon
112.45
KB
-rwxr-xr-x
runlevel
1.29
MB
-rwxr-xr-x
runuser
70.31
KB
-rwxr-xr-x
service
8.89
KB
-rwxr-xr-x
setcap
14.23
KB
-rwxr-xr-x
sfdisk
142.3
KB
-rwxr-xr-x
sgdisk
202.41
KB
-rwxr-xr-x
shadowconfig
2.22
KB
-rwxr-xr-x
shutdown
1.29
MB
-rwxr-xr-x
slattach
41.2
KB
-rwxr-xr-x
sshd
1.21
MB
-rwxr-xr-x
start-stop-daemon
43.42
KB
-rwxr-xr-x
sudo_logsrvd
244.57
KB
-rwxr-xr-x
sudo_sendlog
151.41
KB
-rwxr-xr-x
sulogin
54.31
KB
-rwxr-xr-x
swaplabel
18.3
KB
-rwxr-xr-x
swapoff
22.3
KB
-rwxr-xr-x
swapon
50.3
KB
-rwxr-xr-x
switch_root
18.3
KB
-rwxr-xr-x
sync-available
1.42
KB
-rwxr-xr-x
sysctl
30.31
KB
-rwxr-xr-x
tarcat
936
B
-rwxr-xr-x
tc
574
KB
-rwxr-xr-x
tcptraceroute
1.56
KB
-rwxr-xr-x
tcptraceroute.db
1.56
KB
-rwxr-xr-x
telinit
1.29
MB
-rwxr-xr-x
tipc
152.6
KB
-rwxr-xr-x
traceroute
71.23
KB
-rwxr-xr-x
tune2fs
114.52
KB
-rwxr-xr-x
unix_chkpwd
38.24
KB
-rwxr-sr-x
unix_update
38.24
KB
-rwxr-xr-x
update-ca-certificates
5.29
KB
-rwxr-xr-x
update-catalog
9.17
KB
-rwxr-xr-x
update-grub
64
B
-rwxr-xr-x
update-grub2
64
B
-rwxr-xr-x
update-initramfs
6.75
KB
-rwxr-xr-x
update-locale
2.99
KB
-rwxr-xr-x
update-passwd
38.49
KB
-rwxr-xr-x
update-pciids
1.71
KB
-rwxr-xr-x
update-rc.d
17.33
KB
-rwxr-xr-x
update-secureboot-policy
5.13
KB
-rwxr-xr-x
update-shells
3.89
KB
-rwxr-xr-x
update-xmlcatalog
16.88
KB
-rwxr-xr-x
useradd
155.8
KB
-rwxr-xr-x
userdel
110.95
KB
-rwxr-xr-x
usermod
143.61
KB
-rwxr-xr-x
uuidd
38.81
KB
-rwxr-xr-x
validlocale
1.73
KB
-rwxr-xr-x
vdpa
116.66
KB
-rwxr-xr-x
vigr
72.64
KB
-rwxr-xr-x
vipw
72.64
KB
-rwxr-xr-x
visudo
256.63
KB
-rwxr-xr-x
wipefs
46.31
KB
-rwxr-xr-x
xtables-legacy-multi
88.98
KB
-rwxr-xr-x
xtables-monitor
223.16
KB
-rwxr-xr-x
xtables-nft-multi
223.16
KB
-rwxr-xr-x
zic
58.73
KB
-rwxr-xr-x
zramctl
114.42
KB
-rwxr-xr-x
Delete
Unzip
Zip
${this.title}
Close
Code Editor : mkinitramfs
#!/bin/sh umask 0022 export PATH='/usr/bin:/sbin:/bin' # Defaults keep="n" CONFDIR="/etc/initramfs-tools" verbose="n" # Will be updated by busybox's conf hook, if present BUSYBOXDIR= export BUSYBOXDIR usage() { cat << EOF Usage: mkinitramfs [option]... -o outfile [version] Options: -c compress Override COMPRESS setting in initramfs.conf. -d confdir Specify an alternative configuration directory. -l level Override COMPRESSLEVEL setting in initramfs.conf. -k Keep temporary directory used to make the image. -o outfile Write to outfile. -r root Override ROOT setting in initramfs.conf. See mkinitramfs(8) for further details. EOF } usage_error() { usage >&2 exit 2 } OPTIONS=$(getopt -o c:d:hl:ko:r:v --long help -n "$0" -- "$@") || usage_error eval set -- "$OPTIONS" while true; do case "$1" in -c) compress="$2" shift 2 ;; -d) CONFDIR="$2" shift 2 if [ ! -d "${CONFDIR}" ]; then echo "${0}: ${CONFDIR}: Not a directory" >&2 exit 1 fi ;; -h|--help) usage exit 0 ;; -l) compresslevel="$2" shift 2 ;; -o) outfile="$2" shift 2 ;; -k) keep="y" shift ;; -r) ROOT="$2" shift 2 ;; -v) verbose="y" shift ;; --) shift break ;; *) echo "Internal error!" >&2 exit 1 ;; esac done # For dependency ordered mkinitramfs hook scripts. . /usr/share/initramfs-tools/scripts/functions . /usr/share/initramfs-tools/hook-functions . "${CONFDIR}/initramfs.conf" EXTRA_CONF='' maybe_add_conf() { if [ -e "$1" ] && \ basename "$1" \ | grep '^[[:alnum:]][[:alnum:]\._-]*$' \ | grep -qv '\.dpkg-.*$'; then if [ -d "$1" ]; then echo "W: $1 is a directory instead of file" >&2 else EXTRA_CONF="${EXTRA_CONF} $1" . "$1" fi fi } for i in /usr/share/initramfs-tools/conf.d/*; do # Configuration files in /etc mask those in /usr/share if ! [ -e "${CONFDIR}"/conf.d/"$(basename "${i}")" ]; then maybe_add_conf "${i}" fi done for i in "${CONFDIR}"/conf.d/*; do maybe_add_conf "${i}" done # source package confs for i in /usr/share/initramfs-tools/conf-hooks.d/*; do if [ -d "${i}" ]; then echo "W: ${i} is a directory instead of file." >&2 elif [ -e "${i}" ]; then . "${i}" fi done # Check busybox dependency if [ "${BUSYBOX}" = "y" ] && [ -z "${BUSYBOXDIR}" ]; then echo >&2 "E: busybox or busybox-static, version 1:1.22.0-17~ or later, is required but not installed" exit 1 fi if [ -n "${UMASK:-}" ]; then umask "${UMASK}" fi if [ -z "${outfile}" ]; then usage_error fi touch "$outfile" outfile="$(readlink -f "$outfile")" # And by "version" we really mean path to kernel modules # This is braindead, and exists to preserve the interface with mkinitrd if [ ${#} -ne 1 ]; then version="$(uname -r)" else version="${1}" fi case "${version}" in /lib/modules/*/[!/]*) ;; /lib/modules/[!/]*) version="${version#/lib/modules/}" version="${version%%/*}" ;; esac case "${version}" in */*) echo "$PROG: ${version} is not a valid kernel version" >&2 exit 2 ;; esac if [ -z "${compress:-}" ]; then compress=${COMPRESS?} fi unset COMPRESS if ! command -v "${compress}" >/dev/null 2>&1; then echo "W: No ${compress} in ${PATH}, using gzip" >&2 compress=gzip fi # Check that kernel supports selected compressor, and fall back to gzip. # Exit if even gzip is not supported. case "${compress}" in gzip) kconfig_sym=CONFIG_RD_GZIP ;; bzip2) kconfig_sym=CONFIG_RD_BZIP2 ;; lzma) kconfig_sym=CONFIG_RD_LZMA ;; xz) kconfig_sym=CONFIG_RD_XZ ;; lzop) kconfig_sym=CONFIG_RD_LZO ;; lz4) kconfig_sym=CONFIG_RD_LZ4 ;; zstd) kconfig_sym=CONFIG_RD_ZSTD ;; esac while ! grep -q "^$kconfig_sym=y" "/boot/config-${version}"; do if [ "${compress}" = gzip ]; then echo "E: gzip compression ($kconfig_sym) not supported by kernel" >&2 exit 1 fi echo "W: ${compress} compression ($kconfig_sym) not supported by kernel, using gzip" >&2 compress=gzip kconfig_sym=CONFIG_RD_GZIP done if [ -z "${compresslevel:-}" ]; then compresslevel=${COMPRESSLEVEL:-} fi case "${compress}" in lz4) compresslevel="-${compresslevel:-9}" ;; zstd) compresslevel="-${compresslevel:-9}" ;; #gzip|xz|bzip2|lzma|lzop included *) # We're not using a compression level by default compresslevel="${compresslevel:+-${compresslevel}}" ;; esac unset COMPRESSLEVEL case "${compress}" in gzip) # If we're doing a reproducible build, use gzip -n if [ -n "${SOURCE_DATE_EPOCH}" ]; then compress="gzip -n" # Otherwise, substitute pigz if it's available elif command -v pigz >/dev/null; then compress=pigz fi if [ -n "${compresslevel}" ]; then compress="${compress} ${compresslevel}" fi ;; lz4) compress="lz4 ${compresslevel} -l" ;; zstd) compress="zstd -q ${compresslevel}" # If we're not doing a reproducible build, enable multithreading test -z "${SOURCE_DATE_EPOCH}" && compress="$compress -T0" ;; xz) compress="xz ${compresslevel} --check=crc32" # If we're not doing a reproducible build, enable multithreading test -z "${SOURCE_DATE_EPOCH}" && compress="$compress --threads=0" ;; bzip2|lzma|lzop) compress="${compress} ${compresslevel}" ;; *) echo "W: Unknown compression command ${compress}" >&2 ;; esac if [ -d "${outfile}" ]; then echo "${outfile} is a directory" >&2 exit 1 fi MODULESDIR="/lib/modules/${version}" if [ ! -e "${MODULESDIR}" ]; then echo "W: missing ${MODULESDIR}" >&2 echo "W: Ensure all necessary drivers are built into the linux image!" >&2 fi if [ ! -e "${MODULESDIR}/modules.dep" ]; then depmod "${version}" fi # Prepare to clean up temporary files on exit DESTDIR= __TMPCPIOGZ= __TMPMAINCPIO= __TMPEARLYCPIO= # shellcheck disable=SC2317 clean_on_exit() { if [ "${keep}" = "y" ]; then echo "Working files in ${DESTDIR:-<not yet created>}," \ "early initramfs in ${__TMPEARLYCPIO:-<not yet created>}," \ "main initramfs in ${__TMPMAINCPIO:-<not yet created>} and" \ "overlay in ${__TMPCPIOGZ:-<not yet created>}" else for path in "${DESTDIR}" "${__TMPCPIOGZ}" "${__TMPMAINCPIO}" "${__TMPEARLYCPIO}"; do test -z "${path}" || rm -rf "${path}" done fi } trap clean_on_exit EXIT trap "exit 1" INT TERM # makes the EXIT trap effective even when killed # Create temporary directory and files for initramfs contents [ -n "${TMPDIR}" ] && [ ! -w "${TMPDIR}" ] && unset TMPDIR DESTDIR="$(mktemp -d "${TMPDIR:-/var/tmp}/mkinitramfs_XXXXXX")" || exit 1 chmod 755 "${DESTDIR}" __TMPCPIOGZ="$(mktemp "${TMPDIR:-/var/tmp}/mkinitramfs-OL_XXXXXX")" || exit 1 __TMPMAINCPIO="$(mktemp "${TMPDIR:-/var/tmp}/mkinitramfs-MAIN_XXXXXX")" || exit 1 __TMPEARLYCPIO="$(mktemp "${TMPDIR:-/var/tmp}/mkinitramfs-FW_XXXXXX")" || exit 1 DPKG_ARCH=$(dpkg --print-architecture) # Export environment for hook scripts. # export MODULESDIR export version export CONFDIR export DESTDIR export DPKG_ARCH export verbose export KEYMAP export MODULES export BUSYBOX export RESUME export FSTYPE # Private, used by 'catenate_cpiogz'. export __TMPCPIOGZ # Private, used by 'prepend_earlyinitramfs'. export __TMPEARLYCPIO # Create usr-merged filesystem layout, to avoid duplicates if the host # filesystem is usr-merged. for d in /bin /lib* /sbin; do mkdir -p "${DESTDIR}/usr${d}" ln -s "usr${d}" "${DESTDIR}${d}" done for d in conf/conf.d etc run scripts ${MODULESDIR}; do mkdir -p "${DESTDIR}/${d}" done # Copy in modules.builtin, modules.builtin.modinfo and modules.order (not generated by depmod) # and modules.builtin.bin (generated by depmod, but too late to avoid # error messages as in #948257) for x in modules.builtin modules.builtin.bin modules.builtin.modinfo modules.order; do if [ -f "${MODULESDIR}/${x}" ]; then cp -p "${MODULESDIR}/${x}" "${DESTDIR}${MODULESDIR}/${x}" fi done # MODULES=list case. Always honour. for x in "${CONFDIR}/modules" /usr/share/initramfs-tools/modules.d/*; do if [ -f "${x}" ]; then add_modules_from_file "${x}" fi done # MODULES=most is default case "${MODULES}" in dep) dep_add_modules ;; most) auto_add_modules ;; netboot) auto_add_modules base auto_add_modules net ;; list) # nothing to add ;; *) echo "W: mkinitramfs: unsupported MODULES setting: ${MODULES}." >&2 echo "W: mkinitramfs: Falling back to MODULES=most." >&2 auto_add_modules ;; esac # Resolve hidden dependencies hidden_dep_add_modules # Add firmware for built-in code add_builtin_firmware # First file executed by linux cp -p /usr/share/initramfs-tools/init "${DESTDIR}/init" # add existant boot scripts for b in $(cd /usr/share/initramfs-tools/scripts/ && find . \ -regextype posix-extended -regex '.*/[[:alnum:]\._-]+$' -type f); do [ -d "${DESTDIR}/scripts/$(dirname "${b}")" ] \ || mkdir -p "${DESTDIR}/scripts/$(dirname "${b}")" cp -p "/usr/share/initramfs-tools/scripts/${b}" \ "${DESTDIR}/scripts/$(dirname "${b}")/" done # Prune dot-files/directories and limit depth to exclude VCS files for b in $(cd "${CONFDIR}/scripts" && find . -maxdepth 2 -name '.?*' -prune -o \ -regextype posix-extended -regex '.*/[[:alnum:]\._-]+$' -type f -print); do [ -d "${DESTDIR}/scripts/$(dirname "${b}")" ] \ || mkdir -p "${DESTDIR}/scripts/$(dirname "${b}")" cp -p "${CONFDIR}/scripts/${b}" "${DESTDIR}/scripts/$(dirname "${b}")/" done echo "DPKG_ARCH=${DPKG_ARCH}" > "${DESTDIR}/conf/arch.conf" cp -p "${CONFDIR}/initramfs.conf" "${DESTDIR}/conf" for i in ${EXTRA_CONF}; do copy_file config "${i}" /conf/conf.d done # ROOT hardcoding if [ -n "${ROOT:-}" ]; then echo "ROOT=${ROOT}" > "${DESTDIR}/conf/conf.d/root" fi if ! command -v ldd >/dev/null 2>&1 ; then echo "E: no ldd around - install libc-bin" >&2 exit 1 fi # fstab and mtab touch "${DESTDIR}/etc/fstab" ln -s /proc/mounts "${DESTDIR}/etc/mtab" # module-init-tools copy_exec /sbin/modprobe /sbin copy_exec /sbin/rmmod /sbin mkdir -p "${DESTDIR}/etc/modprobe.d" "${DESTDIR}/lib/modprobe.d" for file in /etc/modprobe.d/*.conf /lib/modprobe.d/*.conf ; do if test -e "$file" || test -L "$file" ; then copy_file config "$file" fi done run_scripts /usr/share/initramfs-tools/hooks run_scripts "${CONFDIR}"/hooks # cache boot run order for b in $(cd "${DESTDIR}/scripts" && find . -mindepth 1 -type d); do cache_run_scripts "${DESTDIR}" "/scripts/${b#./}" done # decompress modules for boot speed, if possible find "${DESTDIR}/${MODULESDIR}" -name '*.ko.*' | while read -r ko; do case "$ko" in *.xz) if ! command -v xz >/dev/null 2>&1; then break fi xz -d "${ko}" ;; *.zst) if ! command -v zstd >/dev/null 2>&1; then break fi zstd -q -d --rm "${ko}" ;; esac done # generate module deps depmod -a -b "${DESTDIR}" "${version}" rm -f "${DESTDIR}/lib/modules/${version}"/modules.*map # make sure that library search path is up to date cp -pPr /etc/ld.so.conf* "$DESTDIR"/etc/ if ! ldconfig -r "$DESTDIR" ; then [ "$(id -u)" != "0" ] \ && echo "ldconfig might need uid=0 (root) for chroot()" >&2 fi # The auxiliary cache is not reproducible and is always invalid at boot # (see #845034) if [ -d "${DESTDIR}"/var/cache/ldconfig ]; then rm -f "${DESTDIR}"/var/cache/ldconfig/aux-cache rmdir --ignore-fail-on-non-empty "${DESTDIR}"/var/cache/ldconfig fi # Apply DSDT to initramfs if [ -e "${CONFDIR}/DSDT.aml" ]; then copy_file DSDT "${CONFDIR}/DSDT.aml" fi [ "${verbose}" = y ] && echo "Building cpio ${outfile} initramfs" ( # preserve permissions if root builds the image, see #633582 [ "$(id -ru)" != 0 ] && cpio_owner_root="-R 0:0" # if SOURCE_DATE_EPOCH is set, try and create a reproducible image if [ -n "${SOURCE_DATE_EPOCH}" ]; then # ensure that no timestamps are newer than $SOURCE_DATE_EPOCH find "${DESTDIR}" -newermt "@${SOURCE_DATE_EPOCH}" -print0 | \ xargs -0r touch --no-dereference --date="@${SOURCE_DATE_EPOCH}" # --reproducible requires cpio >= 2.12 cpio_reproducible="--reproducible" fi # work around lack of "set -o pipefail" for the following pipe: # cd "${DESTDIR}" && find . | LC_ALL=C sort | cpio --quiet $cpio_owner_root $cpio_reproducible -o -H newc >>"${outfile}" || exit 1 ec1=1 ec2=1 exec 3>&1 eval "$( # http://cfaj.freeshell.org/shell/cus-faq-2.html exec 4>&1 >&3 3>&- cd "${DESTDIR}" { find . 4>&-; echo "ec1=$?;" >&4 } | { LC_ALL=C sort } | { # shellcheck disable=SC2086 cpio --quiet $cpio_owner_root $cpio_reproducible -o -H newc 4>&- >"${__TMPMAINCPIO}" echo "ec2=$?;" >&4 } )" if [ "$ec1" -ne 0 ]; then echo "E: mkinitramfs failure find $ec1 cpio $ec2" >&2 exit "$ec1" fi if [ "$ec2" -ne 0 ]; then echo "E: mkinitramfs failure cpio $ec2" >&2 exit "$ec2" fi ) || exit 1 { if [ -s "${__TMPEARLYCPIO}" ]; then cat "${__TMPEARLYCPIO}" || exit 1 fi $compress -c "${__TMPMAINCPIO}" || { echo "E: mkinitramfs failure $compress $?" >&2; exit 1; } if [ -s "${__TMPCPIOGZ}" ]; then cat "${__TMPCPIOGZ}" || exit 1 fi } >"${outfile}" || exit 1 exit 0
Close